﻿# _       __      __       ______                                           __            
#| |     / /___  / /_     / ____/____  ____ ___  ____ ___  ____ _____  ____/ /___  _____  
#| | /| / // _ \/ __ \   / /    / __ \/ __ `__ \/ __ `__ \/ __ `/ __ \/ __  // _ \/ ___/  
#| |/ |/ //  __/ /_/ /  / /___ / /_/ / / / / / / / / / / / /_/ / / / / /_/ //  __/ /      
#|__/|__/ \___/_.___/   \____/ \____/_/ /_/ /_/_/ /_/ /_/\__,_/_/ /_/\__,_/ \___/_/       
#                                                                    2011 - Matthieu Totet
##########################################################################################
#
# Command line crawler 
# Navicrawler inspired
#
##########################################################################################
#ToDo / Idea
#
# - Can perfom Automatic Crawl (Autopilot)
# - Can navigate inside same "Website"
# - Can define 'WebSite' (default is xxx://yyyy.zzz). Like define http://www.mysite.com/blog as a entry point WebSite and should't be interpreted as http://www.mysite.com
# - Add Other component to the Ship to create overview of the page (ie console tag cloud)
# - Jump Code Processor
##########################################################################################
from urlparse import urlparse,urlunparse
import urllib2
import BeautifulSoup    
from consoleIHM import *
from GephiStream import *
from BeautifulSoup import BeautifulSoup
from cmd2 import make_option, options
import cmd2
progHeader() 
class NavCom(cmd2.Cmd):
    ship = None
    mapping =[]
    InMapping = {}
    LocalMapping = []
    HistoryJumpStack = []
    gephiConnector = None ;
    
    ##
    ####
    # Do_ Functions
    ####
    ###    
    def do_save(self,line):
        nodeHeader="nodedef>name VARCHAR\n"
        edgeHeader="edgedef>node1 VARCHAR,node2 VARCHAR,directed BOOLEAN\n"
        nodeContent="";
        edgeContent="";
        nodeList=[]
        for key,link in enumerate(self.mapping):
            if link[0] not in nodeList:
                nodeList.append(link[0])
                nodeContent+='"%s"\n'% link[0]
            if link[1] not in nodeList:
                nodeList.append(link[1])
                nodeContent+='"%s"\n'% link[1]
            edgeContent+='"%s","%s",true\n' % (link[0],link[1])
        
        with open(line+".gdf", 'w') as f:
            f.write(nodeHeader)
            f.write(nodeContent)
            f.write(edgeHeader)
            f.write(edgeContent)
        f.closed
        
    def do_stop(self,line):
        exit()
    def do_upgephi(self,line):
        print(self.colorize("Gephi connector is ON ",'green'))
        self.gephiConnector = GephiStream()
        
    def do_downgephi(self,line):
        print(self.colorize("Gephi connector is OFF ",'green'))
        self.gephiConnector = None        
   
    def do_info(self,line=None):
    
        print(self.colorize("** You Are at %s **" %self.HistoryJumpStack[-1][1],'green'))
        print(self.colorize("** Here are links founded **",'green'))
        for key,url in enumerate(self.LocalMapping):
             print(' > [%d] : %r' % (key,url))
    @options([make_option('-d', '--distance',type="int", help="Distance from scan point")])
    def do_scan(self,line,opt=None):
        params = line.split(" ")
        distanceSite = []
        distanceTemp = []
        distanceHistory = []
        for key,url in enumerate(self.LocalMapping) :
            
            if line =="" or str(key) in params:  
                try:
                    distanceSite.append(self.do_jump(url,True))

                except Exception:
                    print(self.colorize("%s > Fail" %url,'red' ))
                    pass
                distanceHistory.append(url)
       
        while opt != None or opt.distance > 1 :
            print opt.distance
            opt.distance = opt.distance - 1
            
            for url in [item for sublist in distanceSite for item in sublist]:
                try:
                    if url not in distanceHistory:
                        distanceTemp.append(self.do_jump(url,True))
                        
                except Exception:
                    print(self.colorize("%s > Fail" %url,'red' ))
                    pass
                distanceHistory.append(url)
            distanceSite = distanceTemp
            
    def do_jump(self,line,isScanMode=False):
        if line.isdigit():
            target = self.LocalMapping[int(line)]
            typeHistory='|->'
        else:
            target = line
            typeHistory='X->'
        if not isScanMode:
            self.HistoryJumpStack.append([typeHistory,target])
            
        urlTarget = urlparse(target)
        if self.gephiConnector:
            params = self.gephiConnector.commonNodeParams(target,30, 0, 0, 0, 0.5, 0.5, 0.5)
            self.gephiConnector.sendAction(self.gephiConnector.ADD_NODE,target,params)
        print(self.colorize("%s > Downloading " %urlTarget.geturl(),'green' ))
        page = urllib2.urlopen(target)
        print(self.colorize("%s > Downloaded" %urlTarget.geturl(),'green'))
        soup = BeautifulSoup(page)
        print(self.colorize("%s > Analyzing Page" %urlTarget.geturl(),'green'))
        elementA = soup.findAll('a')  
        if not isScanMode:
            self.LocalMapping = []
        i = 0
        tempTab = []
        for valeur in elementA:
            try:
                urlNext = urlparse(valeur['href'])
                if urlNext.netloc.lower() != urlTarget.netloc.lower() and urlNext.netloc !="" and self.refactorSimpleUrl(urlNext).lower() not in self.LocalMapping :
                    if self.gephiConnector:
                        params = self.gephiConnector.commonNodeParams(self.refactorSimpleUrl(urlNext),30, 0, 0, 0, 0.5, 0.5, 0.5)
                        self.gephiConnector.sendAction(self.gephiConnector.ADD_NODE,self.refactorSimpleUrl(urlNext),params)
                        
                        params = self.gephiConnector.commonEdgeParams(target, self.refactorSimpleUrl(urlNext), 1, True, "", 1, 1, 1)
                        self.gephiConnector.sendAction(self.gephiConnector.ADD_EDGE,target+""+self.refactorSimpleUrl(urlNext),params)
                        
                    if not isScanMode:
                        self.LocalMapping.append(self.refactorSimpleUrl(urlNext))
                    else:
                        tempTab.append(self.refactorSimpleUrl(urlNext))
                    if [urlTarget.netloc.lower(),urlNext.netloc.lower()] not in self.mapping:
                        self.mapping.append([self.refactorSimpleUrl(urlTarget),self.refactorSimpleUrl(urlNext)])
                    i = i+1
            except Exception:
                pass
        if not isScanMode:
            self.do_info()
            self.prompt = 'Arrow V  [%s] > @%s : '% (self.colorize("Navcom",'green' ),self.colorize(urlTarget.netloc,'bold' ),)
        else:
            return tempTab
    def do_history(self,line):
         for key,link in enumerate(self.HistoryJumpStack):
            print('%d: %s %s' % (key,link[0],link[1]))
    def do_mapping(self,line):
        for key,link in enumerate(self.mapping):
            print('%d %s -> %s' % (key,link[0],link[1]))
    def do_reset(self,line):
        self.LocalMapping = []
        self.prompt = 'Arrow V  [%s] : '%self.colorize("Navcom",'green' )
        
    ##
    ####
    # Utility and Model Functnion
    ####
    ### 
    
    ########
    # Constructor
    ########
    def __init__(self,ship):
        cmd2.Cmd.__init__(self)
        gephiConnector = GephiStream()
        self.ship = ship
        self.prompt = 'Arrow V  [%s] : '%self.colorize("Navcom",'green' )
    ########
    # Not used NOW
    ########
    def siteSimilarities(url,target):
        return  
    ########
    # Construct base String URL from Url ( http://www.mysite.com/a/query.php?param=eee to http://www.mysite.com)
    ########        
    def refactorSimpleUrl(self,url):
        return urlunparse([url.scheme, url.netloc,'','','',''])   
    ########
    #  
    ########   
        
class ArrowV(cmd2.Cmd):
    navCom = None

    def do_greet(self, line):
        print("hello %s" % self.i)
        
    def do_navcom(self,line):
     
        self.navCom.cmdloop()
    def __init__(self):
        self.navCom = NavCom(self)
        cmd2.Cmd.__init__(self)
        self.prompt = 'Arrow V : '

       

if __name__ == '__main__':
    ArrowV().cmdloop()
