import json
import httplib, urllib
class GephiStream:
    GEPHI_STREAM_URL = "localhost:8080"
    ADD_NODE = "an"
    CHANGE_NODE = "cn"
    DELETE_NODE = "dn"
    
    ADD_EDGE = "ae"
    CHANGE_EDGE = "ce"
    DELETE_EDGE = "de"
    
    def commonEdgeParams(self, source, target, weight, directed, label, red, green, blue):
        return {"source":source,"target":target,"weight":weight,"directed":directed,"label":label,"r":red,"g":green,"b":blue}
        
    def commonNodeParams(self, label, size, x, y, z, red, green, blue):
        return {"label":label,"size":size,"x":x,"y":y,"z":z,"r":red,"g":green,"b":blue}
        
    def sendAction(self,action,id,params):
        postAction = {action:{id:params}}
        params = json.dumps(postAction)
        headers = {"Content-type": "application/x-www-form-urlencoded","Accept": "text/plain"}
        conn = httplib.HTTPConnection(self.GEPHI_STREAM_URL)
        conn.request("POST", "/workspace0?operation=updateGraph", params, headers)
        response = conn.getresponse()
        data = response.read()
        conn.close()
